package com.qmth.distributed.print.business.entity;

import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.io.Serializable;

/**
 * <p>
 * 报告考生表
 * </p>
 *
 * @author wangliang
 * @since 2024-02-18
 */
@ApiModel(value = "TRExamStudent对象", description = "报告考生表")
public class TRExamStudent implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "主键")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long id;

    @ApiModelProperty(value = "报告id")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long rBasicInfoId;

    @ApiModelProperty(value = "考生姓名")
    private String name;

    @ApiModelProperty(value = "学号")
    private String examNumber;

    @ApiModelProperty(value = "行政班级")
    private String clazz;

    @ApiModelProperty(value = "学生成绩")
    private Double score;

    @ApiModelProperty(value = "考生课程考核成绩评价明细结果")
    private String resultDetail;

    public Double getScore() {
        return score;
    }

    public void setScore(Double score) {
        this.score = score;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getrBasicInfoId() {
        return rBasicInfoId;
    }

    public void setrBasicInfoId(Long rBasicInfoId) {
        this.rBasicInfoId = rBasicInfoId;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getExamNumber() {
        return examNumber;
    }

    public void setExamNumber(String examNumber) {
        this.examNumber = examNumber;
    }

    public String getClazz() {
        return clazz;
    }

    public void setClazz(String clazz) {
        this.clazz = clazz;
    }

    public String getResultDetail() {
        return resultDetail;
    }

    public void setResultDetail(String resultDetail) {
        this.resultDetail = resultDetail;
    }
}
