package com.qmth.distributed.print.business.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.IService;
import com.qmth.distributed.print.business.bean.examRule.FieldsDto;
import com.qmth.distributed.print.business.bean.excel.ExcelField;
import com.qmth.distributed.print.business.bean.result.ScoreNormalResult;
import com.qmth.distributed.print.business.entity.TCScoreNormal;

import java.io.IOException;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 平常作业成绩表 服务类
 * </p>
 *
 * @author wangliang
 * @since 2024-02-18
 */
public interface TCScoreNormalService extends IService<TCScoreNormal> {

    /**
     * 成绩管理列表
     *
     * @param iPage
     * @param semesterId
     * @param examId
     * @param courseCode
     * @return
     */
    public IPage<ScoreNormalResult> scoreList(IPage<Map> iPage, Long semesterId, Long examId, String courseCode);

    /**
     * 动态生成excel
     *
     * @param describe
     * @param sheetName
     * @param fileName
     * @param excelFieldList
     * @throws IOException
     */
    void downLoadExaminationTemplate(String describe, String sheetName, String fileName, List<ExcelField> excelFieldList) throws IOException;
}
